Index: trunk/src/VBox/VMM/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 96392)
+++ trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 96393)
@@ -242,4 +242,5 @@
 	tstIEMAImplDataSseBinary-hsubps_u128.bin \
 	tstIEMAImplDataSseBinary-sqrtps_u128.bin \
+	tstIEMAImplDataSseBinary-addsubps_u128.bin \
 	tstIEMAImplDataSseBinary-addpd_u128.bin \
 	tstIEMAImplDataSseBinary-mulpd_u128.bin \
@@ -251,4 +252,5 @@
 	tstIEMAImplDataSseBinary-hsubpd_u128.bin \
 	tstIEMAImplDataSseBinary-sqrtpd_u128.bin \
+	tstIEMAImplDataSseBinary-addsubpd_u128.bin \
 	tstIEMAImplDataSseBinary-addss_u128_r32.bin \
 	tstIEMAImplDataSseBinary-addsd_u128_r64.bin \
Index: trunk/src/VBox/VMM/testcase/tstIEMAImpl.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstIEMAImpl.cpp	(revision 96392)
+++ trunk/src/VBox/VMM/testcase/tstIEMAImpl.cpp	(revision 96393)
@@ -4479,4 +4479,5 @@
     ENTRY_BIN(hsubps_u128),
     ENTRY_BIN(sqrtps_u128),
+    ENTRY_BIN(addsubps_u128),
 };
 
@@ -4676,4 +4677,5 @@
     ENTRY_BIN(hsubpd_u128),
     ENTRY_BIN(sqrtpd_u128),
+    ENTRY_BIN(addsubpd_u128),
 };
 
Index: trunk/src/VBox/VMM/testcase/tstIEMAImpl.h
===================================================================
--- trunk/src/VBox/VMM/testcase/tstIEMAImpl.h	(revision 96392)
+++ trunk/src/VBox/VMM/testcase/tstIEMAImpl.h	(revision 96393)
@@ -760,4 +760,5 @@
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          hsubps_u128              );
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          sqrtps_u128              );
+TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          addsubps_u128            );
 
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_U128_R32_TEST_T, addss_u128_r32           );
@@ -779,4 +780,5 @@
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          hsubpd_u128              );
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          sqrtpd_u128              );
+TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_TEST_T,          addsubpd_u128            );
 
 TSTIEM_DECLARE_TEST_ARRAY_BIN(SseBinary,    SSE_BINARY_U128_R64_TEST_T, addsd_u128_r64           );
Index: trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.S
===================================================================
--- trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.S	(revision 96392)
+++ trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.S	(revision 96393)
@@ -59,4 +59,5 @@
 IEM_TEST_DATA hsubps_u128,       "tstIEMAImplDataSseBinary-hsubps_u128.bin"
 IEM_TEST_DATA sqrtps_u128,       "tstIEMAImplDataSseBinary-sqrtps_u128.bin"
+IEM_TEST_DATA addsubps_u128,     "tstIEMAImplDataSseBinary-addsubps_u128.bin"
 
 IEM_TEST_DATA addss_u128_r32,    "tstIEMAImplDataSseBinary-addss_u128_r32.bin"
@@ -78,4 +79,5 @@
 IEM_TEST_DATA hsubpd_u128,       "tstIEMAImplDataSseBinary-hsubpd_u128.bin"
 IEM_TEST_DATA sqrtpd_u128,       "tstIEMAImplDataSseBinary-sqrtpd_u128.bin"
+IEM_TEST_DATA addsubpd_u128,     "tstIEMAImplDataSseBinary-addsubpd_u128.bin"
 
 IEM_TEST_DATA addsd_u128_r64,    "tstIEMAImplDataSseBinary-addsd_u128_r64.bin"
Index: trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.asm
===================================================================
--- trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.asm	(revision 96392)
+++ trunk/src/VBox/VMM/testcase/tstIEMAImplDataSseBinary.asm	(revision 96393)
@@ -57,4 +57,5 @@
 IEM_TEST_DATA hsubps_u128,          "tstIEMAImplDataSseBinary-hsubps_u128.bin"
 IEM_TEST_DATA sqrtps_u128,          "tstIEMAImplDataSseBinary-sqrtps_u128.bin"
+IEM_TEST_DATA addsubps_u128,        "tstIEMAImplDataSseBinary-addsubps_u128.bin"
 
 IEM_TEST_DATA addss_u128_r32,       "tstIEMAImplDataSseBinary-addss_u128_r32.bin"
@@ -76,4 +77,5 @@
 IEM_TEST_DATA hsubpd_u128,          "tstIEMAImplDataSseBinary-hsubpd_u128.bin"
 IEM_TEST_DATA sqrtpd_u128,          "tstIEMAImplDataSseBinary-sqrtpd_u128.bin"
+IEM_TEST_DATA addsubpd_u128,        "tstIEMAImplDataSseBinary-addsubpd_u128.bin"
 
 IEM_TEST_DATA addsd_u128_r64,       "tstIEMAImplDataSseBinary-addsd_u128_r64.bin"