Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 96499)
@@ -1621,5 +1621,5 @@
   ; disGetNextSymbol 0xf0dba LB 0x400 -> off=0x0 cb=0000000000000018 uValue=00000000000f0dba 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0dba LB 0x18
-    db  'VirtualBox 7.0.0_ALPHA2', 000h
+    db  'VirtualBox 7.0.0_BETA1', 000h, 000h
   ; disGetNextSymbol 0xf0dd2 LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0dd2 '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0dd2 LB 0x8
@@ -19354,3 +19354,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 042h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 08dh
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 96499)
@@ -1,1 +1,1 @@
-9cefc7fc14fd3c0a9476b83aa469f7fa *VBoxPcBios286.rom
+e782ef6cd8095b5ef2eed57b3e9c8028 *VBoxPcBios286.rom
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 96499)
@@ -1566,5 +1566,5 @@
   ; disGetNextSymbol 0xf0df4 LB 0x400 -> off=0x0 cb=0000000000000018 uValue=00000000000f0df4 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0df4 LB 0x18
-    db  'VirtualBox 7.0.0_ALPHA2', 000h
+    db  'VirtualBox 7.0.0_BETA1', 000h, 000h
   ; disGetNextSymbol 0xf0e0c LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0e0c '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0e0c LB 0x8
@@ -19121,3 +19121,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 02ch
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 077h
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 96499)
@@ -1,1 +1,1 @@
-8c884ffefc5748a21ba73a5224486744 *VBoxPcBios386.rom
+0735e9cd6e801b3543464552693f2799 *VBoxPcBios386.rom
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 96499)
@@ -1621,5 +1621,5 @@
   ; disGetNextSymbol 0xf0dba LB 0x400 -> off=0x0 cb=0000000000000018 uValue=00000000000f0dba 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0dba LB 0x18
-    db  'VirtualBox 7.0.0_ALPHA2', 000h
+    db  'VirtualBox 7.0.0_BETA1', 000h, 000h
   ; disGetNextSymbol 0xf0dd2 LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0dd2 '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0dd2 LB 0x8
@@ -19832,3 +19832,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 0abh
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 0f6h
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 96413)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 96499)
@@ -1,1 +1,1 @@
-82178c49315131cad826117b8c6b6fae *VBoxPcBios8086.rom
+cef191b8d31d55110b6960070760aa44 *VBoxPcBios8086.rom